#!/bin/bash

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

# -----------------------------------------------------------------------------------
# --- WIZARD_UIFILE / install_uifile
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
# --- Set language Strings ...
# -----------------------------------------------------------------------------------
init_lang() {
/bin/cat << EOF
inTitle1              = "Hibernation :"
# -----------------------------------------------------------------------------------
inTitleDesc           = "<u><b>Important :</b></u> "
inTitleDesc          += "Please note that AvrLogger will prevent your NAS from <b>hibernation!</b>. "
inTitleDesc          += "<u><b>As long</b></u> as <b>Time scheduling</b> is not activated.<br>"
inTitleDesc          += "<br>"
inTitleDesc          += "AvrLogger offers the possibility to change the fan speed via the <b>scemd.xml</b>. "
inTitleDesc          += "This function is <b>experimental</b> and the use of the function is <b>expressly</b> at your own risk!<br>"
inTitleDesc          += "<br>"
inTitleDesc          += "<u><b>Recommendation :</b></u> "
inTitleDesc          += "AvrLogger should be quit via the package center <b>before</b> changes to the network settings "
inTitleDesc          += "<b>or</b> in the Storage Manager so that they are recognized without problems."
# -----------------------------------------------------------------------------------
inBoxCheckDesc        = "Okay, taken note."
inBoxCheckValidator   = "Please check : <b>Okay, taken note.</b> to continue!"
# -----------------------------------------------------------------------------------
inTitle3              = "RamDisk (Shared Memory) :"
inTitleDesc3          = "AvrLogger can use a <b>RamDisk (shared memory)</b>. This can minimize disk access and speed up "
inTitleDesc3         += "file operation.<br>"
 
inTitleDesc3_1        = "However, there is a risk that in the event of an unforeseen restart of the DiskStation,<br>"
inTitleDesc3_1       += "e.g. in the event of a power outage, data and settings go missing. In this case, AvrLogger "
inTitleDesc3_1       += "will try to restore the data and settings since the last start."

inBoxCheckDesc3       = "Yes, use a RamDisk (shared memory)."
inBoxCheckDesc3_1     = "Okay, taken note."
inBoxCheckValidator3  = "Please check : <b>Okay, taken note.</b> to continue!"
EOF
}

# -----------------------------------------------------------------------------------
# --- json WIZARD_UIFILE
# -----------------------------------------------------------------------------------
init_wizard() {
/bin/cat << EOF
[{
   "step_title": "${inTitle1}",
   "items": [{
      "type": "multiselect",
      "desc": "${inTitleDesc}",
      "subitems": [{
         "defaultValue": false,
         "desc":         "${inBoxCheckDesc}",
         "key":          "wizCheckNote",
         "validator":    {"fn": "{var v=arguments[0]; if (!v) return '${inBoxCheckValidator}'; return true;}"}
                  }]
         }]
},{
   "step_title": "${inTitle3}",
   "items": [{
      "type": "multiselect",
      "desc": "${inTitleDesc3}",
      "subitems": [{
         "defaultValue": true,
         "desc":         "${inBoxCheckDesc3}",
         "key":          "wizCheckShm"
         }]
   },{
      "type": "multiselect",
      "desc": "${inTitleDesc3_1}",
      "subitems": [{
         "defaultValue": false,
         "desc":         "${inBoxCheckDesc3_1}",
         "key":          "wizCheckShmNote",
         "validator":    {"fn": "{var v=arguments[0]; if (!v) return '${inBoxCheckValidator3}'; return true;}"}
                 }]
         }]

}]
EOF
}

# -----------------------------------------------------------------------------------
# --- Prepare "json WIZARD_UIFILE" ...
# -----------------------------------------------------------------------------------
var=""
while IFS= read -r line; do
   if [[ -n "${line%%\#*}" ]]; then
      value="${line#*\"}"
      if [ -z "${line/* \+\= *}" ]
         then var+="${line%% *}+=\"${value%\"*}\"\n"
         else var+="${line%% *}=\"${value%\"*}\"\n"
      fi
   fi
done <<<"$(init_lang)"
source <(echo -e $var)
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
echo -e "$(init_wizard)" > $SYNOPKG_TEMP_LOGFILE
# -----------------------------------------------------------------------------------

exit 0

# ---- END ----
