# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

from   textwrap     import dedent, indent

import asset
from   Html  import *
import lib

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName    = 'changelog'

# ---------------------------------------------------------------------------------
# --- Pre-Initialization
# ---------------------------------------------------------------------------------
def pre( site, more ):
   pass

# ---------------------------------------------------------------------------------
# --- Post-Initialization
# ---------------------------------------------------------------------------------
def post( site, more ):
   pass

# -----------------------------------------------------------------------------------
# --- "Changelog" - Page
# -----------------------------------------------------------------------------------
def Func( site=False, more=False, WhatsNew=False ):

   if not WhatsNew :
      WhatsNew = lib.InitLanguage( asset.sysCookies['SynoUser'], asset.avrWhatsNewFile, suffix='.html', opt=True )

   print ( dedent( f'''\
      Content-type: text/html

      <!DOCTYPE html>
      <html xmlns="http://www.w3.org/1999/xhtml">
         <head>
            <title> -- AvrLogger@Changelog -- </title>
            <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
            <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
            <link rel="shortcut icon" href="images/avrlogger_32.png" type="image/x-icon" />
            <link rel="stylesheet" type="text/css" href="css/News.css?v={asset.cssVersion}"/>
            <link rel="stylesheet" type="text/css" href="../../help/help.css?v={asset.cssVersion}"/>
            <link rel="stylesheet" type="text/css" href="../../help/scrollbar/flexcroll.css"/>
            <script type="text/javascript" src="../../help/scrollbar/flexcroll.js"></script>
            <script type="text/javascript" src="../../help/scrollbar/initFlexcroll.js"></script>
         </head>
         <body style="margin-left:0px; margin-top:0px;">
            <div class="content">''') )

   # --- Print content of File ...
   print ( indent( WhatsNew, prefix='         ' ) )

   print ( dedent( f'''\
            </div>
         </body>
      </html>''' ) )

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
