# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'grid'

FuncDesc = { 'IconName'     : 'Grid.png',
             'SubName'      : asset.msg['modChartGridName'],
             'SubText'      : asset.msg['modChartGridText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False ,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'page+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

         # --------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "grid"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight - iMainSaveHeight )
   # --------------------------------------------------------------------------------
   Section( 'GridSettings' )

   RowOpen ()
   CheckBox( 'Pri1MainGridOn',     'Pri1MainGridOn',        Column_1 )
   Color   ( 'Pri1MainGridColor',  'GridColor',             Column_2b, Box_Color )
   Select  ( 'Pri1MainGridStroke', 'GridStroke', '1 3 5 7', Column_2b, Box_1b )
   RowClose()

   RowOpen ()
   CheckBox( 'Pri1HelpGridOn',     'Pri1HelpGridOn',        Column_1 )
   Color   ( 'Pri1HelpGridColor',  'GridColor',             Column_2b, Box_Color )
   Select  ( 'Pri1HelpGridStroke', 'GridStroke', '1 3 5 7', Column_2b, Box_1b )
   RowClose()

   RowOpen ()
   CheckBox( 'VerMainGridOn',      'VerMainGridOn',         Column_1 )
   Color   ( 'VerMainGridColor',   'GridColor',             Column_2b, Box_Color )
   Select  ( 'VerMainGridStroke',  'GridStroke', '1 3 5 7', Column_2b, Box_1b )
   RowClose()

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
