# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'index'

FuncDesc = { 'IconName'     : 'z-Index.png',
             'SubName'      : asset.msg['modChartIndexName'],
             'SubText'      : asset.msg['modChartIndexText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange' ,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ):

   if '#' in more : more, sub = more.split ( '#', 1 )
   Out = asset.Out

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'index+save' ):
         # --------------------------------------------------------------------------
         Key     = Out['SvgBaseName'].split(' ')
         svgPrio = dict()

         sList = asset.cgiInput.get( 'SvgBaseList', Out['SvgBaseList'] )
         for sID in sList.split(' ') :
            iID = int( sID )
            try:    svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio'] ] += ' ' + sID
            except: svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio'] ] =        sID

         svgBaseList = []

         for iID in reversed( range( 0, asset.iTabLast ) ) :
            sID = str( iID )
            if not sID in svgPrio : continue
            svgBaseList.append( svgPrio[ sID ] )

         asset.cgiInput['SvgBaseList'] = ' '.join( svgBaseList )

         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      if case( 'index+OnChange' ) :
         # --------------------------------------------------------------------------
         # --- Select-Box ...
         # --------------------------------------------------------------------------
         Key = Out['SvgBaseName'].split(' ')
         svgPrio = dict()

         sList = asset.cgiInput.get( 'SvgBaseList', Out['SvgBaseList'] )
         for sID in sList.split(' ') :
            iID = int( sID )
            try:    svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio']] +=  ' ' + sID
            except: svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio']]  =        sID

         svgBaseList = []

         for iID in reversed(range( 0, asset.iTabLast )):
            sID = str ( iID )
            if not sID in svgPrio : continue
            svgBaseList.append( svgPrio[ sID ] )

         asset.cgiInput['SvgBaseList'] = ' '.join( svgBaseList )
         break

      # -----------------------------------------------------------------------------
      # --- Up / Down - Arrow ...
      # -----------------------------------------------------------------------------
      if case( 'index+up', 'index+down' ) :
         Key = Out['SvgBaseName'].split(' ')

         iID  = int( sub )
         prio = int( asset.cgiInput['Plot' + Key[ iID ] + 'Prio'] )

         if more == "down" and prio < asset.TabLast : prio += 1
         if more ==   "up" and prio >             0 : prio -= 1

         asset.cgiInput['Plot' + Key[ iID ] + 'Prio'] = str( prio )

         svgPrio = dict()

         sList = asset.cgiInput.get( 'SvgBaseList', Out['SvgBaseList'] )
         for sID in sList.split(' ') :
            iID = int( sID )
            try:    svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio']] +=  ' ' + sID
            except: svgPrio[ asset.cgiInput['Plot' + Key[ iID ] + 'Prio']]  =        sID

         svgBaseList = []

         for id in reversed(range( 0, asset.iTabLast )):
            if not str(id) in svgPrio : continue
            svgBaseList.append( svgPrio[str(id)] )

         asset.cgiInput['SvgBaseList'] = ' '.join( svgBaseList )

         break
      # -----------------------------------------------------------------------------
      break

   # --- Prepare Values ...
   for key in asset.cgiInput :
      asset.Out[key] = asset.cgiInput[key]


# -----------------------------------------------------------------------------------
# --- Function : "index"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight - iMainSaveHeight )
   # --------------------------------------------------------------------------------
   Section( 'ChartIndex' )

   Key =  Split ( Out['SvgBaseName'] )
   List = Split ( Out['SvgBaseList'] )
   nice=  Split ( Out['SvgBaseDesc'] )

   zIndex = []
   for a in range( 0, asset.iTabLast ):
      zIndex.append( str(a) )

   zIndex = ' '.join( zIndex )

   for a in range( len(List) - 1, -1, -1 ):
      id = int(List[a])
      RowOpen  ()
      Label    ( nice[id],                                         Column_1 )
      RoBox    ( 'Plot' + Key[id] + 'Label',   'ID',               20, Box_1a )
      Color    ( 'Plot' + Key[id] + 'Color',   '&nbsp;',           10, Box_Color )
      Label    ( '&nbsp;',                                         10 )
      Button   ( 'ButtonUpDown', '▲', f'{asset.PageName}-{FuncName}+up#{ str( id ) }', iSize=40 )
      Select   ( 'Plot' + Key[id] + 'Prio',  '', zIndex,   0, 50, True )
      Button   ( 'ButtonUpDown', '▼', f'{asset.PageName}-{FuncName}+down#{ str( id ) }', iSize=40 )
      RowClose ()

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()


# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
