# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'page'

FuncDesc = { 'IconName'     : 'Chart.png',
             'SubName'      : asset.msg['modChartPageName'],
             'SubText'      : asset.msg['modChartPageText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'page+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

         # --------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "page"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 140 )
   # --------------------------------------------------------------------------------

   Section( 'ChartTimeline' )

   RowOpen ()
   Select  ( 'LogBase',       'LogBase', '1 2 3 6 12 24 48 168', Column_1, 60 )
   RowClose()

   RowOpen ()
   Select  ( 'SvgTick',       'Update:', '1 2 5 10 20 30 60',    Column_1, 60 )
   RowClose()

   RowOpen ()
   CheckBox ( 'LogRealtimeOn', 'LogRealtimeOn',                   Column_1 )
   RowClose()

   ContentTabEnd()
   # --------------------------------------------------------------------------------
   ContentTab( 390, 140 )
   # --------------------------------------------------------------------------------

   Section( 'ChartPage' )

   RowOpen ()
   Select  ( 'BorderStroke', 'BorderStroke', '0 5 10 15 20',     Column_1, Box_1b )
   RowClose()

   RowOpen ()
   Color   ( 'BorderColor',  'GridColor',                        Column_1, Box_Color )
   RowClose()

   RowOpen ()
   Color   ( 'BorderFill',   'BorderFill',                       Column_1, Box_Color )
   RowClose()

   RowOpen ()
   Color   ( 'PlotAreaFill', 'PlotAreaFill',                     Column_1, Box_Color )
   RowClose()

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab( 390, 140 )
   # --------------------------------------------------------------------------------

   Section( 'ChartPageSize' )

   RowOpen ()
   Input   ( 'PageSizeWidht',  'LegTabX',                     Column_1, Box_1b )
   RowClose()

   RowOpen ()
   Input   ( 'PageSizeHeight', 'LegTabY',                     Column_1, Box_1b )
   RowClose()

   ContentTabEnd()

   # --------------------------------------------------------------------------------
   ContentTab( 390, 140 )
   # --------------------------------------------------------------------------------

   Section( 'ChartPageMargins' )

   RowOpen ()
   Input   ( 'PlotEdgeLeft',   'PlotEdgeLeft',                Column_1,  Box_1b )
   RowClose()

   RowOpen ()
   Input   ( 'PlotEdgeRight',  'PlotEdgeRight',               Column_1, Box_1b )
   RowClose()

   RowOpen ()
   Input   ( 'PlotEdgeTop',    'PlotEdgeTop',                 Column_1, Box_1b )
   RowClose()

   RowOpen ()
   Input   ( 'PlotEdgeBottom', 'PlotEdgeBottom',              Column_1, Box_1b )
   RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()


# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
