# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html import *

from   lib      import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'archive'

FuncDesc = { 'IconName'     : 'Archive.png',
             'SubName'      : asset.msg['modConfigArchiveName'],
             'SubText'      : asset.msg['modConfigArchiveText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

GuiTime_H   = "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23"
GuiTime_M   = "0 5 10 15 20 25 30 35 40 45 50 55"

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'archive+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'archive+folder' ):
         break

      # -----------------------------------------------------------------------------
      if case( 'archive+backup' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                  # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelBackup'],           # Title / header
                     'FolderMode'       : 'GetFolder',                           # Function inside
                     'FolderHome'       : '',                                    # Select a "Home" folder
                     'FolderCurDir'     : asset.cgiInput['SvgArchivePath'],      # Start directory
                     'FolderCurFile'    : '',                                    # Preselected file
                     'FolderCurExt'     : '*',                                   # File extension (filter)
                     'FileIcon'         : '',                                    # File Icon
                     'FolderRetName'    : 'SvgArchivePath'                       # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      if case( 'archive+path' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                  # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-{FuncName}+folder', # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelArchive'],          # Title / header
                     'FolderMode'       : 'GetFolder',                           # Function inside
                     'FolderHome'       : '',                                    # Select a "Home" folder
                     'FolderCurDir'     : asset.cgiInput['SvgArchiveFolder'],    # Start directory
                     'FolderCurFile'    : '',                                    # Preselected file
                     'FolderCurExt'     : '*',                                   # File extension (filter)
                     'FileIcon'         : '',                                    # File Icon
                     'FolderRetName'    : 'SvgArchiveFolder'                     # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      if case( 'archive+copy' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                                 # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-{FuncName}+folder',                # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-{FuncName}+folder',                # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelSvgCopy'],                         # Title / header
                     'FolderMode'       : 'GetFile',                                            # Function inside
                     'FolderHome'       : '',                                                   # Select a "Home" folder
                     'FolderCurDir'     : os.path.dirname ( asset.cgiInput['SvgCopyPath'] ),    # Start directory
                     'FolderCurFile'    : os.path.basename( asset.cgiInput['SvgCopyPath'] ),    # Preselected file
                     'FolderCurExt'     : '*.svg',                                              # File extension (filter)
                     'FileIcon'         : 'svg.png',                                            # File Icon
                     'FolderRetName'    : 'SvgCopyPath'                                         # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         CallPage ( sDict )
         sys.exit()
         break
      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight - 150 )
   # --------------------------------------------------------------------------------
 
   Section ( 'Sicherung' )

   Path = lib.FindeShare ( Out['SvgArchivePath'] )
   if Path : asset.Out['SvgArchivePath'] = Path[1]

   RowOpen ()
   Label   ( 'SvgArchivePath', 169 )
   Button  ( 'ButtonSelectFolder', '- Select -'    , f'{asset.PageName}-{FuncName}+backup', iSize=80 )
   RoBox   ( 'SvgArchivePath'    , '', 0, 480, opt=not Path )
   RowClose()

   # --------------------------------------------------------------------------------
   Section ( 'Achivierung' )
   if not Out['SvgArchiveFolder'] : asset.Out['SvgArchiveFolder'] = Out['SvgArchivePath'] + '/archive'

   Path = lib.FindeShare ( Out['SvgArchiveFolder'] )
   if Path : asset.Out['SvgArchiveFolder'] = Path[1]

   RowOpen ()
   Select  ( 'SvgArchiveMode'    , 'SvgArchiveMode'  , 'Off Time Day Base Stop', Column_1, Box_1 )
   Select  ( 'SvgArchiveStd'     , 'SvgArchiveStd'   , GuiTime_H,  22, 50 )
   Select  ( 'SvgArchiveMin'     , ':'               , GuiTime_M,  0, 50 )
   RowClose()

   RowOpen ()
   Label   ( 'Archivierungsordner :', Column_1 )
   Button  ( 'ButtonSelectFolder', '- Select -'      , f'{asset.PageName}-{FuncName}+path', iSize=80 )
   RoBox   ( 'SvgArchiveFolder'  , '', 0, 480, opt=not Path )
   RowClose()

   # --------------------------------------------------------------------------------
   Section ( 'Chart' )
   sPath = os.path.dirname ( Out['SvgCopyPath'] )
   sFile = os.path.basename( Out['SvgCopyPath'] )

   Path = lib.FindeShare ( sPath )
   if Path : asset.Out['SvgCopyPath'] = Path[1] + '/' + sFile

   RowOpen ()
   CheckBox( 'SvgCopyOn',   'SvgCopyOn',           Column_1 )
   RowClose()

   RowOpen ()
   Label   ( 'Ziel :', Column_1 )
   Button  ( 'ButtonSelectCopy', '- Select -', f'{asset.PageName}-{FuncName}+copy', iSize=80 )
   RoBox   ( 'SvgCopyPath', '',            0, 480, opt=not Path )
   RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   Hide ( 'SvgArchivePath'   )
   Hide ( 'SvgArchiveFolder' )
   Hide ( 'SvgCopyPath'      )

   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
