# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *
from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'expert'

FuncDesc = { 'IconName'     : 'Advanced.png',
             'SubName'      : asset.msg['modConfigExpertName'],
             'SubText'      : asset.msg['modConfigExpertText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'expert+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ) :

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 140 )
   # --------------------------------------------------------------------------------

   Section ( 'ExpertMode' )

   RowOpen ()
   CheckBox( 'ExpertModeOn',     'ExpertModeOn',         Column_1 )
   RowClose()

   RowOpen ()
   CheckBox( 'HintModeOn',       'HintModeOn',           Column_1 )
   RowClose()

   RowOpen ()
   CheckBox( 'BaseListAlwaysOn', 'BaseListAlwaysOn',     Column_1 )
   RowClose()

   if not asset.f_Dsm7 :
      RowOpen ()
      CheckBox( 'AdminNotification', 'AdminNotification',     Column_1 )
      RowClose()

   ContentTabEnd()

   if pMain.Avr[ 'sysExcludeSCEMD' ] == 'No' :
      # -----------------------------------------------------------------------------
      ContentTab( 390, 140 )
      # -----------------------------------------------------------------------------
      Section ( 'Lüftereinstellung' )
      RowOpen ()
      CheckBox( 'FanControlOn',      'ScemdControlOn',    Column_1 )
      RowClose()

      RowOpen ()
      CheckBox( 'FanProtocolOn',     'FanProtocolOn',     Column_1 )
      RowClose()

      RowOpen ()
      CheckBox( 'FanConfirmationOn', 'Wait for Task:',   Column_1 )
      RowClose()

      ContentTabEnd()

   ContentRowEnd()

   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab( 390, 140 )
   # --------------------------------------------------------------------------------
   Section ( 'Accuracy' )

   RowOpen ()
   Select  ( 'LogAccuracy', 'LogAccuracy',  'high middle low yawn',   Column_1, 70 )
   RowClose()

   RowOpen ()
   Select  ( 'LogDataDiv',  'LogDataDiv',   '400 600 900 1200',       Column_1, 70 )
   RowClose()

   RowOpen ()
   Select  ( 'LogSMA',      'LogSMA',       '3 5 10 20 35 50 75',     Column_1, 70 )
   RowClose()

   RowOpen ()
   CheckBox( 'LogClearOn',  'LogClearOn',                             Column_1 )
   RowClose()

   ContentTabEnd()

   # --------------------------------------------------------------------------------
   ContentTab( 390, 140 )
   # --------------------------------------------------------------------------------
   Section ( 'Fenster- / PopUp-Verhalten' )
   RowOpen ()
   CheckBox( 'PopUpStickyOn',     'PopUpStickyOn',       Column_1 )
   RowClose()

   RowOpen   ()
   SelectGUI ( 'PollingFrequency','PollingFrequency', Out['PollingFrequencyGUI'], Out['PollingFrequencyRAW'], Column_1, 60 )
   RowClose  ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
