# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

import lib
from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'mail'

FuncDesc = { 'IconName'     : 'Email.png',
             'SubName'      : asset.msg['modConfigMailName'],
             'SubText'      : asset.msg['modConfigMailText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange',
           }
 
GuiTime_H   = "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23"
GuiTime_M   = "0 5 10 15 20 25 30 35 40 45 50 55"

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ):
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ):

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case ( 'mail+OnChange' ) :
         break

      # -----------------------------------------------------------------------------
      if case( 'mail+save' ) :
         # --------------------------------------------------------------------------
         if 'GuiMail' not in globals() :
            import Status
            Status.init( cgi=True )

            asset.eMailMask = Status.eMailMask
            asset.eMailList = Status.eMailList

            if True in asset.eMailMask : asset.GuiMail = True
            else                       : asset.GuiMail = False

         # --------------------------------------------------------------------------
         for ID, Value in enumerate( asset.Out["StatusMailOn"].split( ' ' ) ) :
            if asset.eMailMask[ ID ] : Value = asset.cgiInput[ 'GuiStatusOn' + str( ID + 1 ) ]
            else                     : Value = "No"

            try    : MailTo += ' ' + Value
            except : MailTo  =       Value

         asset.cgiInput["StatusMailOn"] = MailTo

         # --------------------------------------------------------------------------
         import main
         main.save()

         break

      # -----------------------------------------------------------------------------
      if case( 'mail+test' ) :
         # --- Send a testmail ...
         jBusy( 'msgCgiWaitEmail', iFlush=True )

         # -----------------------------------------------------------------------
         import Status
         Status.init()

         if Status.TestMail() :
            lib.Note( sSection='Email', sTitel='TitelTest', sText='TestFalse', i18n=True )
            return "Info-log"
         else :
            lib.Note( sSection='Email', sTitel='TitelTest', sText='TestTrue',  i18n=True )
         # -----------------------------------------------------------------------
         break

      # -----------------------------------------------------------------------------
      if case( 'mail+report' ) :
         # --- Send a test "Status Report" email ...
         jBusy( 'msgCgiWaitEmail', iFlush=True )

         # -----------------------------------------------------------------------
         pMain.AvrSmart  = False
         import Status
         Status.init( cgi=True )

         if Status.StatusMail( f_TestMail=True, iReport=True ) :
            return "Info-log"

         # -----------------------------------------------------------------------
         break


      # -----------------------------------------------------------------------------
      break

   # --- Prepare Values ...
   for key in asset.cgiInput :
      asset.Out[key] = asset.cgiInput[key]

# -----------------------------------------------------------------------------------
# --- Function : "mail"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   if 'GuiMail' not in globals() :
      import Status
      Status.init( cgi=True )

      asset.eMailMask = Status.eMailMask
      asset.eMailList = Status.eMailList

      if True in asset.eMailMask : asset.GuiMail = True
      else                       : asset.GuiMail = False

   GuiMail   = asset.GuiMail

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 265 )    # <<- First Tab
   # --------------------------------------------------------------------------------
   Section  ( 'StatusMail' )

   if GuiMail :
      for ID, Value in enumerate( Out["StatusMailOn"].split( ' ' ) ):
         if not asset.eMailMask[ ID ] : continue

         sKey = 'GuiStatusOn' + str( ID + 1 )
         asset.Out['EmailToText'] = asset.eMailList[ ID ]
         asset.Out[ sKey ]        = Value

         RowOpen  ()
         CheckBox ( sKey, 'StatusMailTo', 40 )
         BlueText ( 'EmailToText', '', 0, 280 )
         RowClose ()

   ContentTabEnd()
   # --------------------------------------------------------------------------------
   ContentTab ( 390, 265 )    # <<- Second Tab
   # --------------------------------------------------------------------------------
   Section ( 'StatusContent' )

   if GuiMail :

      RowOpen  ()
      SelectGUI( 'StatusMailMode',    'StatusMailMode',    s['StatusMailModeGUI'], Out['StatusMailModeRAW'], Column_1d, 105 )
      Select   ( 'StatusMailTimeH',   'StatusMailTimeH',   GuiTime_H, 20, 50 )
      Select   ( 'StatusMailTimeM',   ':',                 GuiTime_M,  0, 50 )
      RowClose ()

      RowOpen  ()
      CheckBox ( 'StatusMailClearOn', 'Clear:',            Column_1d )
      RowClose ()

      RowOpen  ()
      CheckBox ( 'StatusMailSysOn',   'StatusMailSysOn', Column_1d )
      RowClose ()

      RowOpen  ()
      CheckBox ( 'StatusMailLogOn',   'StatusMailLogOn', Column_1d )
      RowClose ()

      if pMain.Avr[ 'sysVirtualDSM' ] == 'No' :
         RowOpen ()
         SelectGUI( 'StatusMailDrive',    'StatusMailDrive',    s['StatusMailDriveGUI'], Out['StatusMailDriveRAW'], Column_1d, 140 )
         RowClose()

      if 'Yes' in Out["StatusMailOn"] :

         RowOpen ()
         Label   ( s['StatusReportSend'], Column_1d )
         Button  ( 'ButtonStatusReport',  s['ButtonStatusReportTxt'],   f'{asset.PageName}-{FuncName}+report', iSize=80 )
         RowClose()

         RowOpen ()
         Label   ( s['StatusTestmailSend'], Column_1d )
         Button  ( 'ButtonStatusTestmail',  s['ButtonStatusReportTxt'], f'{asset.PageName}-{FuncName}+test', iSize=80 )
         RowClose()

   ContentTabEnd()
   ContentRowEnd()

   if GuiMail :
      # -----------------------------------------------------------------------------
      # --- Display "Save" & "Undo" Button ...
      SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
