# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import os
import glob

import main
import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'manage'

FuncDesc = { 'IconName'     : 'Floppy.png',
             'SubName'      : asset.msg['modConfigManageName'],
             'SubText'      : asset.msg['modConfigManageText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

iList       = [ 'ColorFileLast', 'PresetFileLast', 'UserFileLast', 'SvgArchivePath' ]

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'manage+configsave' ) :
         SavePreset( mask='config', sName='UserFileLast' )
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+layoutsave' ) :
         SavePreset( mask='preset', sName='PresetFileLast' )
         break

      # ---------------------------------------------------------------------------
      if case( 'manage+shemasave' ) :
         SavePreset( mask='scheme', sName='ColorFileLast' )
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+save' ) :
         arr = lib.FindeShare ( asset.cgiInput['SvgArchivePath'] )
         if arr : asset.cgiInput['SvgArchivePath'] = arr[1]
         SaveLast( asset.PageName, iList )
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+shema' ) :
         GetFullPath( 'ColorFileLast' )
         SaveLast( asset.PageName, iList )
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+layout' ) :
         GetFullPath( 'PresetFileLast' )
         SaveLast( asset.PageName, iList )
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+config' ) :
         GetFullPath( 'UserFileLast' )
         SaveLast( asset.PageName, iList )
         break

      # ---------------------------------------------------------------------------
      if case( 'manage+shemaload' ) :
         import Config
         import time
         pst = Config.Configs( sSource=asset.cgiInput['ColorFileLast'] )

         asset.cgiInput = { **pst.sSource }
         asset.cgiInput['SvgTimeStamp'] = str( int( time.time() ) )
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+layoutload' ) :
         import Config
         import time
         pst = Config.Configs( sSource=asset.cgiInput['PresetFileLast'] )

         asset.cgiInput = { **pst.sSource }
         asset.cgiInput['SvgTimeStamp'] = str( int( time.time() ) )
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+configload' ) :
         import Config
         import time
         pst = Config.Configs( sSource=asset.cgiInput['UserFileLast'] )

         asset.cgiInput = { **pst.sSource }
         asset.cgiInput['SvgTimeStamp'] = str( int( time.time() ) )
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      # --- Return point for "folder" ...
      if case( 'manage+cancel' ) :
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+selConfig' ) :
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                                 # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-manage+config',                    # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-manage+cancel',                    # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelGeneral'],                         # Title / header
                     'FolderMode'       : 'GetFile',                                            # Function inside
                     'FolderHome'       : asset.avrPresetFiles,                                 # Select a "Home" folder
                     'FolderCurDir'     : os.path.dirname ( asset.cgiInput['UserFileLast'] ),   # Start directory
                     'FolderCurFile'    : os.path.basename( asset.cgiInput['UserFileLast'] ),   # Preselected file
                     'FolderCurExt'     : '*.cnf',                                              # File extension (filter)
                     'FileIcon'         : 'cnf.png',                                            # File Icon
                     'FolderRetName'    : 'UserFileLast'                                        # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         SaveLast( asset.PageName, iList )
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+selLayout' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                                 # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-manage+layout',                    # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-manage+cancel',                    # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelLayout'],                          # Title / header
                     'FolderMode'       : 'GetFile',                                            # Function inside
                     'FolderHome'       : asset.avrPresetFiles,                                 # Select a "Home" folder
                     'FolderCurDir'     : os.path.dirname ( asset.cgiInput['PresetFileLast'] ), # Start directory
                     'FolderCurFile'    : os.path.basename( asset.cgiInput['PresetFileLast'] ), # Preselected file
                     'FolderCurExt'     : '*.pst',                                              # File extension (filter)
                     'FileIcon'         : 'pst.png',                                            # File Icon
                     'FolderRetName'    : 'PresetFileLast'                                      # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         SaveLast( asset.PageName, iList )
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+selShema' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                                 # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-manage+shema',                     # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-manage+cancel',                    # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelColor'],                           # Title / header
                     'FolderMode'       : 'GetFile',                                            # Function inside
                     'FolderHome'       : asset.avrPresetFiles,                                 # Select a "Home" folder
                     'FolderCurDir'     : os.path.dirname ( asset.cgiInput['ColorFileLast'] ),  # Start directory
                     'FolderCurFile'    : os.path.basename( asset.cgiInput['ColorFileLast'] ),  # Preselected file
                     'FolderCurExt'     : '*.col',                                              # File extension (filter)
                     'FileIcon'         : 'col.png',                                            # File Icon
                     'FolderRetName'    : 'ColorFileLast'                                       # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         SaveLast( asset.PageName, iList )
         CallPage ( sDict )
         sys.exit()
         break

      # -----------------------------------------------------------------------------
      if case( 'manage+selSave' ):
         # --------------------------------------------------------------------------
         # --- Prepare File-Manager Args .......
         sDict = {   'page'             : 'folder-folder+init',                                 # Page to be called up
                     'CalledPageOk'     : f'{asset.PageName}-manage+save',                      # Calling page "- Ok -"
                     'CalledPageCancel' : f'{asset.PageName}-manage+cancel',                    # Calling page "- Cancel -"
                     'FolderBaseTitel'  : asset.msg['cgiTitelBackup'],                          # Title / header
                     'FolderMode'       : 'GetFolder',                                          # Function inside
                     'FolderHome'       : "",                                                   # Select a "Home" folder
                     'FolderCurDir'     : asset.cgiInput['SvgArchivePath'],                     # Start directory
                     'FolderCurFile'    : '',                                                   # Preselected file
                     'FolderCurExt'     : '*',                                                  # File extension (filter)
                     'FileIcon'         : '',                                                   # File Icon
                     'FolderRetName'    : 'SvgArchivePath'                                      # Return name
                  }

         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         # --------------------------------------------------------------------------
         # --- Call File-Manager (Folder-Mode) ...
         SaveLast( asset.PageName, iList )
         CallPage ( sDict )
         sys.exit()
         break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Store / Save a List of Value's
# -----------------------------------------------------------------------------------
def SaveLast ( PageName, iList ) :

   asset.Last     = { **asset.cgiInput }
   asset.cgiInput = dict()

   for sID in iList :
      asset.cgiInput[sID] = asset.Last[sID]

   main.save()

   asset.cgiInput = { **asset.Last }

# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
def SavePreset ( config=False, mask=False, sName=False ) :

   import Config

   if config : sSource = config
   else      : sSource = asset.avrConfigFile

   sMask = f'{asset.avrPresetFiles}/{mask}.mask'

   pst = Config.Configs( sSource=sSource )
   io.ioWrite( pst.Preset( sMask ), asset.cgiInput[sName] )

   # --------------------------------------------------------------------------------
   sPath = os.path.dirname ( asset.cgiInput[sName] )
   sName = os.path.basename( asset.cgiInput[sName] )
   sName, sType = os.path.splitext( sName )
   sType = sType.strip( '.' )

   # --------------------------------------------------------------------------------
   import Svg
   sDst  = f'{sPath}/{sName}.{sType}.svg'
   Svg.PreView( pre=sDst )

# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
def Background( sName, isFile=False ) :
   if not isFile or sName not in asset.Out : return False

   import glob

   sPath = os.path.dirname ( asset.Out[sName] )
   sName = os.path.basename( asset.Out[sName] )
   sName, sType = os.path.splitext( sName )
   sType = sType.strip( '.' )

   # --------------------------------------------------------------------------------
   sSrc  = f'{sPath}/{sName}.{sType}.svg'

   if not os.path.isfile( sSrc ) : return False

   # --------------------------------------------------------------------------------
   sGlob = f'{asset.avrImagesFiles}/{sType}_*.svg'
   for sFile in glob.glob( sGlob ) :
      io.ioRm( sFile )

   # --------------------------------------------------------------------------------
   dstName =  '{0}_{1}.svg'.format( sType, int( time.time() ) )
   sDst    = f'{asset.avrImagesFiles}/{dstName}'

   # --------------------------------------------------------------------------------
   try :
      io.ioCopy ( sSrc, sDst )
      return dstName
   except :
      return False

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   sPreView = False
   # --------------------------------------------------------------------------------
   iTimeStamp = asset.cgiInput.get ('SvgTimeStamp', False )
   
   if iTimeStamp :
      iTimeStamp = int( iTimeStamp )

      while not sPreView :
         for sFile in glob.glob( asset.avrImagesFiles + '/tmp_*.svg' ) :
            sPreView = os.path.basename( sFile )
            break

         if sPreView and io.ioStat( sFile ) < iTimeStamp :
            sPreView = False

   # --------------------------------------------------------------------------------
   sPreView = False
   for sFile in glob.glob( asset.avrImagesFiles + '/tmp_*.svg' ) :
      sPreView = os.path.basename( sFile )
      break

   # --------------------------------------------------------------------------------
   f  = io.ShareTree( isRoot=True )

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight )
   # --------------------------------------------------------------------------------

   Section ( 'ManageGeneral' )

   if not Out['UserFileLast'] :
      if Out['SvgArchivePath'] : asset.Out['UserFileLast'] = '{0}/Config-0.cnf'.format( Out['SvgArchivePath'] )
      else :                     asset.Out['UserFileLast'] = '{0}/Config-0.cnf'.format( asset.avrPresetFiles )

   Load, Save, asset.Out['UserFileLast'], asset.Out['UserFileNice'] = f.PathExist( Out['UserFileLast'], isFile=True, nice=True )
   sOpt = Background( 'UserFileLast', isFile=Load )

   RowOpen  ()
   Label    ( s['dec_UserFileAct'], 170 )
   Button   ( 'ButtonSelectSetting',  '- Select -', f'{asset.PageName}-manage+selConfig', iSize=70 )
   RoBox    ( 'UserFileNice', '', 0, 500, opt=not Load )
   RowClose ()
   
   if Load or Save :
      if Load :
         RowOpen  ()
         Label    ( 'Load :', 170 )
         pButton  ( 'ButtonLoadSetting',  '- Load -', f'{asset.PageName}-manage+configload', iSize=70, opt=sOpt )
         RowClose ()

      if Save :
         RowOpen  ()
         Label    ( 'Save :', 170 )
         pButton  ( 'ButtonSaveSetting',  '- Save -', f'{asset.PageName}-manage+configsave', iSize=70, opt=sPreView )
         RowClose ()

   # --------------------------------------------------------------------------------
   Section ( 'ManagePreset' )

   if not Out['PresetFileLast'] : asset.Out['PresetFileLast'] = '{0}/Clear.pst'.format( asset.avrPresetFiles )

   Load, Save, asset.Out['PresetFileLast'], asset.Out['PresetFileNice'] = f.PathExist( Out['PresetFileLast'], isFile=True, nice=True )
   sOpt = Background( 'PresetFileLast', isFile=Load )

   RowOpen  ()
   Label    ( s['dec_PresetFileAct'], 170 )
   Button   ( 'ButtonPlotSetting',  '- Select -', f'{asset.PageName}-manage+selLayout', iSize=70 )
   RoBox    ( 'PresetFileNice', '', 0, 500, opt=not Load )
   RowClose ()

   if Load or Save :
      if Load :
         RowOpen  ()
         Label    ( 'Load :', 170 )
         pButton  ( 'ButtonLoadPreset',  '- Load -', f'{asset.PageName}-manage+layoutload', iSize=70, opt=sOpt )
         RowClose ()

      if Save :
         RowOpen  ()
         Label    ( 'Save :', 170 )
         pButton  ( 'ButtonSavePreset',  '- Save -', f'{asset.PageName}-manage+layoutsave', iSize=70, opt=sPreView )
         RowClose ()

   # --------------------------------------------------------------------------------
   Section ( 'ManageColor' )

   if not Out['ColorFileLast'] : asset.Out['ColorFileLast'] = '{0}/Dark 2.col'.format( asset.avrPresetFiles )

   Load, Save, asset.Out['ColorFileLast'], asset.Out['ColorFileNice'] = f.PathExist( Out['ColorFileLast'], isFile=True, nice=True )
   sOpt = Background( 'ColorFileLast', isFile=Load )

   RowOpen  ()
   Label    ( s['dec_ColorFileAct'], 170 )
   Button   ( 'ButtonColorSetting',  '- Select -', f'{asset.PageName}-manage+selShema', iSize=70 )
   RoBox    ( 'ColorFileNice', '', 0, 500, opt=not Load )
   RowClose ()

   if Load or Save :
      if Load :
         RowOpen  ()
         Label    ( 'Load :', 170 )
         pButton  ( 'ButtonLoadColor',  '- Load -', f'{asset.PageName}-manage+shemaload', iSize=70, opt=sOpt )
         RowClose ()

      if Save :
         RowOpen  ()
         Label    ( 'Save :', 170 )
         pButton  ( 'ButtonSaveColor',  '- Save -', f'{asset.PageName}-manage+shemasave', iSize=70, opt=sPreView )
         RowClose ()

   # --------------------------------------------------------------------------------
   Section ( 'BackUpNow' )

   if Out['PopUpStickyOn'] != 'Yes' : sSticky = True
   else                             : sSticky = False

   Load, Save, sFull, asset.Out['SvgArchivePath'] = f.PathExist( Out['SvgArchivePath'], nice=True )

   RowOpen  ()
   Label    ( s['dec_SvgArchivePath'], 170 )
   Button   ( 'ButtonBackupSetting',  '- Select -', f'{asset.PageName}-manage+selSave', iSize=70 )
   RoBox    ( 'SvgArchivePath', '', 0, 487, opt=not Save )
   RowClose ()

   if Load or Save :
      RowOpen   ()
      Label     ( 'BackupConfirm', 170 )

      if Save : popButton ( 'ButtonArchiveNow',     '- Save -', 'log-log+backup',  iWidth=1075, iHight=650, iSize=70, iClose=sSticky, sCgi='AvrConfig' )
      if Load : popButton ( 'ButtonRestoreNow',     '- Load -', 'log-log+restore', iWidth=1075, iHight=650, iSize=70, iClose=sSticky, sCgi='AvrConfig' )

      RowClose  ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   Hide ( 'ColorFileLast'  )
   Hide ( 'PresetFileLast' )
   Hide ( 'UserFileLast'   )
   Hide ( 'SvgArchivePath' )

   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
