# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

import lib
from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'note'

FuncDesc = { 'IconName'     : 'alert.png',
             'SubName'      : asset.msg['modNoteAlertName'],
             'SubText'      : asset.msg['modNoteAlertText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange',
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'note+save' ) :
         # --------------------------------------------------------------------------
         if 'GuiMail' not in globals() :
            import Status
            Status.init( cgi=True )

            asset.eMailMask = Status.eMailMask
            asset.eMailList = Status.eMailList

            if True in asset.eMailMask : asset.GuiMail = True
            else                       : asset.GuiMail = False

         # --------------------------------------------------------------------------
         for ID, Value in enumerate( asset.Out["StatusAlertMailOn"].split( ' ' ) ):
            if asset.eMailMask[ ID ] : Value = asset.cgiInput[ 'GuiStatusOn' + str( ID + 1 ) ]
            else                      : Value = "No"

            try    : MailTo += ' ' + Value
            except : MailTo  =       Value

         # --------------------------------------------------------------------------
         asset.cgiInput["StatusAlertMailOn"] = MailTo

         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      if case( 'note+OnChange' ) :
         break

      # -----------------------------------------------------------------------------
      if case( 'note+test' ) :
         import Push

         if not Push.Test( asset.cgiInput['StatusPushDeviceID'] ) :
            lib.Note( sSection='Pushbullet', sTitel='Titel', sText='TestFalse', i18n=True )
         else :
            lib.Note( sSection='Pushbullet', sTitel='Titel', sText='TestTrue',  i18n=True )

         # --------------------------------------------------------------------------
         break

      # -----------------------------------------------------------------------------
      if case( 'note+refresh' ) :
         jBusy( 'msgCgiWaitPushUpdate', iFlush=True )

         import Push
         if Push.Init ( asset.AvrConf['StatusPushToken'], False ) :
            asset.cgiInput['StatusPushDeviceGUI']  = pMain.Avr['StatusPushDeviceGUI']
            asset.cgiInput['StatusPushDeviceRAW']  = pMain.Avr['StatusPushDeviceRAW']
            asset.cgiInput['StatusPushDeviceID']   = pMain.Avr['StatusPushDeviceID']
            asset.cgiInput['StatusPushUserName']   = pMain.Avr['StatusPushUserName']
            asset.cgiInput['StatusPushDeviceName'] = pMain.Avr['StatusPushDeviceName']
            asset.cgiInput['StatusPushDeviceIden'] = pMain.Avr['StatusPushDeviceIden']

            import main
            main.save()
            break
         else :
            return 'Info-log'
         break

      # -----------------------------------------------------------------------------
      if case( 'note+init' ) :
         jBusy( 'msgCgiWaitPushInit', iFlush=True )

         import Push
         if Push.Init( asset.cgiInput['StatusPushToken'] ) :
            asset.cgiInput['StatusPushRegistered'] = "Yes"
            asset.cgiInput['StatusPushToken']      = asset.AvrConf['StatusPushToken']
            asset.cgiInput['StatusPushDeviceGUI']  = asset.AvrConf['StatusPushDeviceGUI']
            asset.cgiInput['StatusPushDeviceRAW']  = asset.AvrConf['StatusPushDeviceRAW']
            asset.cgiInput['StatusPushDeviceID']   = asset.AvrConf['StatusPushDeviceID']
            asset.cgiInput['StatusPushUserName']   = asset.AvrConf['StatusPushUserName']
            asset.cgiInput['StatusPushDeviceName'] = asset.AvrConf['StatusPushDeviceName']
            asset.cgiInput['StatusPushDeviceIden'] = asset.AvrConf['StatusPushDeviceIden']
            import main
            main.save()
            break
         else :
            return 'Info-log'
         break

      # -----------------------------------------------------------------------------
      if case( 'note+remove' ) :
         asset.cgiInput['StatusPushRegistered'] = "No"
         asset.cgiInput['StatusPushDeviceGUI']  = "\"All\""
         asset.cgiInput['StatusPushDeviceRAW']  = "9999"
         asset.cgiInput['StatusPushDeviceID']   = "9999"
         asset.cgiInput['StatusPushUserName']   = ""
         asset.cgiInput['StatusPushDeviceName'] = ""
         asset.cgiInput['StatusPushDeviceIden'] = ""

         import main as main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight
   iIndent  = 19
   iAccCnt  = 0

   Out = asset.Out
   s   = asset.msg

   if 'GuiMail' not in globals() :
      import Status
      Status.init( cgi=True )

      asset.eMailMask = Status.eMailMask
      asset.eMailList = Status.eMailList

      if True in asset.eMailMask : asset.GuiMail = True
      else                       : asset.GuiMail = False

   # --------------------------------------------------------------------------------
   if Out['ExpertModeOn'] == 'Yes': ExpertMode = True
   else                           : ExpertMode = False

   # --------------------------------------------------------------------------------
   GuiMail = asset.GuiMail

   if Out['StatusPushRegistered'] != 'Yes' : GuiPush = False
   else                                    : GuiPush = True

   # --------------------------------------------------------------------------------
   asset.Out['AcdActive'] = 1

   for key in asset.cgiInput :
      if 'AcdReturn' in key and asset.cgiInput[key] == 'Yes' :
         asset.Out['AcdActive'] = int( key.split( '_', 1 )[-1] )
         break

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight - 150 )
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'StatusAlert', iIndex=iAccCnt )

   # --------------------------------------------------------------------------------
   Section ( 'StatusAlertDelay' )

   RowOpen ()
   Select  ( 'StatusAlertDelayUp',   'StatusAlertDelayUp',   '5 10 15 30 45 60',   Column_1, Box_1b )
   CheckBox( 'StatusAlertLogUpOn',   'StatusAlertLogOn',     Column_2a )
   Color   ( 'StatusAlertColorUp',   'StatusAlertColor',     Column_2a, Box_Color )
   RowClose()

   RowOpen ()
   Select  ( 'StatusAlertDelayDown', 'StatusAlertDelayDown', '5 10 15 30 45 60',   Column_1, Box_1b )
   CheckBox( 'StatusAlertLogDownOn', 'StatusAlertLogOn',     Column_2a )
   Color   ( 'StatusAlertColorDown', 'StatusAlertColor',     Column_2a, Box_Color )
   RowClose()

   if GuiMail:
      Section ( 'StatusAlertMail' )
      for ID, Value in enumerate( Out["StatusAlertMailOn"].split( ' ' ) ):
         if not asset.eMailMask[ ID ] : continue

         sKey = 'GuiStatusOn' + str( ID + 1 )
         asset.Out['EmailToText'] = asset.eMailList[ ID ]
         asset.Out[ sKey ]        = Value

         RowOpen  ()
         CheckBox ( sKey, 'StatusAlertMailTo', Column_1 )
         BlueText ( 'EmailToText', '', 0, 280 )
         RowClose ()

   # --------------------------------------------------------------------------------
   Section ( 'StatusPush' )

   if GuiPush :
      RowOpen  ()
      SelectGUI( 'StatusPushDeviceID', 'StatusPushDevice',  Out['StatusPushDeviceGUI'], Out['StatusPushDeviceRAW'], Column_1, 200 )
      Button   ( 'ButtonPushRefresh',  'ButtonPushRefresh', f'{asset.PageName}-{FuncName}+refresh', iSize=80 )
      Button   ( 'ButtonPushTest',     'ButtonPushTest',    f'{asset.PageName}-{FuncName}+test', iSize=80 )
      RowClose ()

      RowOpen   ()
      Label     ( Out['StatusPushUserName'] + ' :', Column_1, opt=iIndent )
      Button    ( 'ButtonPushRemove', 'ButtonPushRemove',   f'{asset.PageName}-{FuncName}+remove', iSize=90 )
      RowClose  ()
   else :
      RowOpen  ()
      Input    ( 'StatusPushToken',    'StatusPushToken',   Column_1, 275 )
      if Out['StatusPushRegistered'] :
         Button   ( 'ButtonPushInit',     'ButtonPushInit',    f'{asset.PageName}-{FuncName}+init', iSize=90 )
      else :
         Button   ( 'ButtonPushInit',     'ButtonPushInit',    f'{asset.PageName}-{FuncName}+init', 'ButtonPushInitNew', iSize=90 )
      RowClose ()

   SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Temperature', iIndex=iAccCnt )

   Alert ( 'CPU',    'CPU °C :',         GuiPush, GuiMail )
   Alert ( 'Status', 'Thermal Status :', GuiPush, GuiMail )
   Alert ( 'HddMax', 'HDD max. °C :',    GuiPush, GuiMail )
   Alert ( 'HddMin', 'HDD min. °C :',    GuiPush, GuiMail )
   Alert ( 'HddAvr', 'HDD avr. °C :',    GuiPush, GuiMail )
   Alert ( 'i2c',    'i2c NAS °C :',     GuiPush, GuiMail )

   for iID, sID in enumerate( asset.sTabEnv ):
      if Out['PlotAmbiente' + sID + 'On'] == "Yes" : Alert ( 'Ambiente' + sID, 'Ambiente °C %s :' % asset.dTabEnv[ iID ], GuiPush, GuiMail )

   SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'LoadPercent', iIndex=iAccCnt )

   Alert ( 'Load',  'System Load :',   GuiPush, GuiMail )
   Alert ( 'Pwm',   'Fan Speed :',     GuiPush, GuiMail )

   if Out['RamSelectDevice'] != "none" or ExpertMode:
      GUI = s['SelectRamGUI'].split( '" "' )
      sel = Out['RamDeviceListRAW'].split( ' ' )
      for j in range ( 0, len(sel) ):
         if sel[j] == Out['RamSelectDevice'] :
            break

      Alert ( 'Memory', 'RAM: ' + GUI[j].strip( '"' ) + ' :', GuiPush, GuiMail )

   SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Network_IO', iIndex=iAccCnt )


   if ( Out['PlotPingOn'] and Out['SpeedTestOn'] != "No" ) or ExpertMode :
      Alert ( 'Ping', 'Ping (ms) :',          GuiPush, GuiMail )

   GUI = Out['EthDeviceListGUI'].split( '" "' )
   sel = Out['EthDeviceListRAW'].split( ' ' )
   for i in range ( 0, asset.TabEth_Max ) :
      if Out['Eth' + str(i) + 'Device'] != "none" or ExpertMode :
         for j in range ( 0, len(sel) ) :
            if sel[j] == Out['Eth' + str(i) + 'Device'] :
               break
         ID = GUI[j].replace( ' ', '' )
         ID = ID.replace( '#', '' )
         Alert ( 'Eth' + str(i) + 'r', ID.strip( '"' ) + ' receive :',  GuiPush, GuiMail )
         Alert ( 'Eth' + str(i) + 'w', ID.strip( '"' ) + ' transmit :', GuiPush, GuiMail )

   SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Storage_IO', iIndex=iAccCnt )

   GUI = Out['MdDeviceListGUI'].split( '" "' )
   sel = Out['MdDeviceListRAW'].split(  ' '  )
   for i in range ( 0, asset.TabMd_Max ) :
      if Out['Md' + str(i) + 'Device'] != "none" or ExpertMode :
         for j in range ( 0, len(sel) ) :
            if sel[j] == Out['Md' + str(i) + 'Device'] :
               break
         ID = GUI[j].replace( ' ', '' )
         ID = ID.replace( '#', '' )
         Alert ( 'Md' + str(i) + 'r', ID.strip( '"' ) + ' read :',  GuiPush, GuiMail )
         Alert ( 'Md' + str(i) + 'w', ID.strip( '"' ) + ' write :', GuiPush, GuiMail )

   SectionClose()

   # --------------------------------------------------------------------------------
   if Out['PlotUsvLoadOn'] or Out['PlotUsvDischargeOn'] or Out['PlotUsvInputOn'] or ExpertMode :

      iAccCnt += 1
      SectionOpen( 'UpsInput_IO', iIndex=iAccCnt )

      if Out['PlotUsvLoadOn'     ] : Alert ( 'UsvLoad',      'USV Load :',        GuiPush, GuiMail )
      if Out['PlotUsvDischargeOn'] : Alert ( 'UsvDischarge', 'USV Discharged :',  GuiPush, GuiMail )
      if Out['PlotUsvInputOn'    ] : Alert ( 'UsvInput',     'USV Voltage :',     GuiPush, GuiMail )
 
      SectionClose()
   # --------------------------------------------------------------------------------

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
