# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName = 'view'

FuncDesc = { 'IconName'     : False,
             'SubName'      : False,
             'SubText'      : False,
             'iWidth'       : False,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   if '#' in more : more, sub = more.split ( '#', 1 )
   else           : sub = False

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'view+reset' ):
         if sub :
            import Smart
            f = Smart.Smart( )
            f.resetDenote( sub )

         return f'{asset.PageName}-{FuncName}+{sub}'

      # -----------------------------------------------------------------------------
      break      

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "view"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iAccCnt  = 0

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   iOutWidth   = iWidth - 23
   iOutHeight  = iHeight -44

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   import Smart
   f = Smart.Smart( )
   if sMore not in f.scanDrives()[ 'iSdl' ] :
      return 'Hdd'

   sDisk = f.getDiskInfo( sMore )
   sAlertDev    = sDisk[ 'denote' ]
   sDiskHistory = f.getDiskHistory( sMore )
   sAttrHistory = f.getAttrHistory( sMore )

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight )
   # --------------------------------------------------------------------------------

   sHeadLine = '{loc} drive ({0}) : {vendor} {model}-{serial} [{size}]'.format( sMore, **sDisk  )
   Section( sHeadLine )

   print ( '               <div id="ShareScroll" class="ScrollBar OverFlowHeadLine"> <!-- Start DivScroll -->' )

   # --------------------------------------------------------------------------------
   asset.Out['AcdActive'] = 2

   # --------------------------------------------------------------------------------
   iLine  = 675
   if sDisk[ 'isUSB' ] :
      asset.Out['AcdActive'] = 1
      # -----------------------------------------------------------------------------
      # --- Get "current" USB-Device infos ...
      import Usb
      sSmart = Usb.getUsbDevices( sUsb=sMore, iNice=True )[ sMore ]
      # -----------------------------------------------------------------------------
      iAccCnt += 1
      SectionOpen( 'USB', iIndex=iAccCnt )

      sLine  = Colorize( sSmart[ 'product' ], 'Black', True ) + f' ({sSmart[ "manufacturer" ]})'
      RowOpen  ( sClass='SmartRow' )
      Label    ( 'Device :', Column_2a )
      Label    ( sLine, iLine ) 
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Label    ( 'Serial :', Column_2a )
      Label    ( sSmart[ 'serial' ], iLine )
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Label    ( 'Connection :', Column_2a )
      Label    ( sSmart[ 'UsbSpeed' ], iLine )
      RowClose ()

      for index, sMount in enumerate( sSmart[ 'UsbMount' ] ) :
         RowOpen  ( sClass='SmartRow' )
         Label    ( 'Mount :', Column_2a )
         Label    ( sSmart[ 'UsbMount' ][ index ], iLine )
         RowClose ()

         RowOpen  ( sClass='SmartRow' )
         Label    ( 'Share :', Column_2a )
         Label    ( Colorize( sSmart[ 'UsbShare' ][ index ] , 'Black', True ), iLine )
         RowClose ()

      SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Device', iIndex=iAccCnt )
   iLine  = 560

   import smartEsc
   IdCtrl = smartEsc.NvmeIdCtrl

   if sMore.startswith( 'nvme' ) :
      # -----------------------------------------------------------------------------
      # --- Output of "nvme" Device values ...
      # -----------------------------------------------------------------------------
      Section ( 'NVME Identify Controller :' )

      RowOpen  ( sClass='SmartRow' )
      Label    ( Colorize( 'Attribut',  'Black', True ), 420 )    # Attribut
      Label    ( Colorize( 'Value',     'Black', True ), 340 )    # Value
      RowClose ()

      sSmart = sDisk[ 'sInfo' ]
      for sKey in sSmart[ 'iKey' ] :

         if sKey.startswith( 'ps' ): continue

         AttrName = IdCtrl.get( sKey, False )
         if AttrName : AttrName = AttrName[1]
         else        : AttrName = sKey

         RowOpen  ( sClass='SmartRow' )
         Label    ( f'{AttrName} :', 410 )
         Label    ( sSmart[ 'sValue' ][ sKey ], 340 )
         RowClose ()

      # -----------------------------------------------------------------------------
      Section ( 'Power Management :' )

      RowOpen  ( sClass='SmartRow' )
      Label    ( Colorize( 'Power',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Maximum',  'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Entry',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Exit',     'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Relative', 'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Relative', 'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Relative', 'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Relative', 'Black', True ), 85, sAlign='Center' )
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Label    ( Colorize( 'State',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Power',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Latency',  'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Latency',  'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Read',     'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Read',     'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Write',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Write',    'Black', True ), 85, sAlign='Center' )
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Label    ( Colorize( '',           'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( '',           'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( '',           'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( '',           'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Throughput', 'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Latency',    'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Throughput', 'Black', True ), 85, sAlign='Center' )
      Label    ( Colorize( 'Latency',    'Black', True ), 85, sAlign='Center' )
      RowClose ()

      for sID in range( 0, 11 ) :
         sPower = sSmart[ 'sValue' ].get( f'ps {sID}', False )
         if not sPower : continue

         Attr = sPower.split( ' ' )
         Attr.pop( 1 )

         RowOpen  ( sClass='SmartRow' )
         Label    ( f'{sID}', 85, sAlign='Center' )

         for iCount in range( 0, 7 ) :
            Label    ( Attr[ iCount ].split( ':', 1 )[1], 85, sAlign='Center' )

         RowClose ()

      # -----------------------------------------------------------------------------
      sSmart = sDisk[ 'sConf' ]

      if sSmart.get( 'iKey', False )  :
         Section ( 'NVME Identify Namespace :' )

         RowOpen  ( sClass='SmartRow' )
         Label    ( Colorize( 'Attribut',  'Black', True ), 420 )    # Attribut
         Label    ( Colorize( 'Value',     'Black', True ), 340 )    # Value
         RowClose ()

         for sKey in sSmart[ 'iKey' ] :

            AttrName = IdCtrl.get( sKey, False )
            if AttrName : AttrName = AttrName[1]
            else        : AttrName = sKey

            RowOpen  ( sClass='SmartRow' )
            Label    ( f'{AttrName} :', 410 )
            Label    ( sSmart[ 'sValue' ][ sKey ], 340 )
            RowClose ()

   else :
      # -----------------------------------------------------------------------------
      # --- Output of "sata" Device values ...
      # -----------------------------------------------------------------------------
      sSmart = sDisk[ 'sInfo' ]
      for sKey in sSmart[ 'iKey' ] :

         RowOpen  ( sClass='SmartRow' )
         Label    ( f'{sKey} :', 190 )
         Label    ( sSmart[ 'sValue' ][ sKey ], iLine )
         RowClose ()

      sSmart = sDisk[ 'sConf' ]

      if sSmart.get( 'iKey', False )  :
         for sKey in sSmart[ 'iKey' ] :

            RowOpen  ( sClass='SmartRow' )
            Label    ( f'{sKey} :', 190 )
            Label    ( sSmart[ 'sValue' ][ sKey ], iLine )
            RowClose ()

   SectionClose()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'S.M.A.R.T. Values', iIndex=iAccCnt )

   sAlert = smartEsc.iSmartImportant
   sIcon  = smartEsc.iSmartSign
   sSmart = sDisk[ 'sAttr' ]

   if sMore.startswith( 'nvme' ) :
      # -----------------------------------------------------------------------------
      # --- Output of "nvme" SMART values ...
      # -----------------------------------------------------------------------------
      RowOpen  ( sClass='SmartRow' )
      Icon     ( 'empty.png' )
      Label    ( '&nbsp;',                                15, 10 )
      Label    ( Colorize( 'Attribut',  'Black', True ), 390 )                   # Attribut
      Label    ( Colorize( 'Value',     'Black', True ),  45, sAlign='Right' )   # Value
   #  Label    ( Colorize( 'RAW-Value', 'Black', True ), 200 )                   # RAW-Value
      RowClose ()

      for sID in sSmart[ 'iKey' ] :
         iAttr = sSmart[ 'sValue' ][ sID ]

         RowOpen  ( sClass='SmartRow' )
         Icon     ( 'empty.png' )
         Label    ( '&nbsp;',                                15, 10 )
         Label    ( f'{sID}', 390 )
         Label    ( iAttr[0],  45, sAlign='Right' )
         Label    ( iAttr[1], 200 )
         RowClose ()

   else :
      # -----------------------------------------------------------------------------
      # --- Normal output of SMART values ...
      # -----------------------------------------------------------------------------
      RowOpen  ( sClass='SmartRow' )
      Icon     ( 'empty.png' )
      Label    ( Colorize( '#ID',       'Black', True ),  30, sAlign='Right' )      # ID
      Label    ( '&nbsp;',                                15, 10 )
      Label    ( Colorize( 'Attribut',  'Black', True ), 300 )                      # Attribut

      Label    ( Colorize( 'Value',     'Black', True ),  45, sAlign='Center' )     # Value
      Label    ( Colorize( 'Worst',     'Black', True ),  45, sAlign='Center' )     # Worst
      Label    ( Colorize( 'Limit',     'Black', True ),  45, sAlign='Center' )     # Threshold

      Label    ( Colorize( 'RAW-Value', 'Black', True ), 100, sAlign='Right' )      # RAW-Value
      RowClose ()

      for sID in sSmart[ 'iKey' ] :
         iAttr = sSmart[ 'sValue' ][ sID ]
         sText = ''
             
         if sID in sAlert :
            if sAlertDev and sID in sAlertDev :
               sSign = 'RedSquare.png'
               if sAttrHistory.get( sID, False )  :
                  sText += s['modHddAlertHistory']
                  for sItem in sorted( sAttrHistory[ sID ][ 'List' ] ) :
                     sText += '&nbsp;&nbsp;&nbsp;&nbsp;{0} : <b>{1}</b> to <b class="red">{2}</b><br>'.format( sItem, sAttrHistory[ sID ][ 'List' ][sItem][0], sAttrHistory[ sID ][ 'List' ][sItem][1] )

               sText += s['modHddAlertSmartNote']
               sText += s['modHddAlertSmartRaw'] + sAlertDev[ sID ][1] + s['modHddAlertSmartTo'] + sAlertDev[ sID ][2] + '</b>'

            else :
               if sAttrHistory.get( sID, False )  :
                  sSign = 'BlueSmartHint.png'
                  sText = s['modHddAlertHistory']
                  for sItem in sorted( sAttrHistory[ sID ][ 'List' ] ) :
                     sText += '&nbsp;&nbsp;&nbsp;&nbsp;{0} : <b>{1}</b> to <b class="red">{2}</b><br>'.format( sItem, sAttrHistory[ sID ][ 'List' ][sItem][0], sAttrHistory[ sID ][ 'List' ][sItem][1] )
               else :
                  sSign = sIcon[ sAlert[ sID ] ]
         else :
            sSign = 'empty.png'

         RowOpen  ( sClass='SmartRow' )
         Icon     ( sSign, sText )
         Label    ( sID, 30, sAlign='Right' )         # ID
         Label    ( ':',  5, 10 )
         Label    ( iAttr[0], 300 )                   # Attribut

         Label    ( iAttr[1], 45, sAlign='Center' )   # Value
         Label    ( iAttr[2], 45, sAlign='Center' )   # Worst
         Label    ( iAttr[3], 45, sAlign='Center' )   # Threshold

         Label    ( iAttr[4], 100, sAlign='Right' )   # RAW-Value

         if not iAttr[5] : iAttr[5] = '&nbsp;'
         Label    ( iAttr[5], 110, 10 )               # RAW-Value additionals

         RowClose ()

   SectionClose()

   # --------------------------------------------------------------------------------
   if sMore.startswith( 'nvme' ) :
      iAccCnt += 1
      SectionOpen( 'Device Error-Information', iIndex=iAccCnt )

      sSmart = sDisk[ 'sError' ]

      # -----------------------------------------------------------------------------
      # --- Output of "nvme" SMART values ...
      # -----------------------------------------------------------------------------
      iColumn = 60
      RowOpen  ( sClass='SmartRow' )
      Label    ( Colorize( 'Num',      'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'ErrCnt',   'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'SQId',     'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'CmdId',    'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'Status',   'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'PELoc',    'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'LBA',      'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'NSID',     'Black', True ), iColumn, sAlign='Center' )
      Label    ( Colorize( 'VS',       'Black', True ), iColumn, sAlign='Center' )
      RowClose ()

      for sID in sSmart[ 'iKey' ] :
         iAttr = sSmart[ 'sValue' ][ sID ]

         if sID != 'Entry 0' and iAttr[0] == '0' : continue

         RowOpen  ( sClass='SmartRow' )
         Label    ( sID.split( ' ', 1 )[-1], iColumn, sAlign='Center' )
         Label    ( iAttr[0], iColumn, sAlign='Center' )
         Label    ( iAttr[1], iColumn, sAlign='Center' )
         Label    ( iAttr[2], iColumn, sAlign='Center' )
         Label    ( iAttr[3], iColumn, sAlign='Center' )
         Label    ( iAttr[4], iColumn, sAlign='Center' )
         Label    ( iAttr[5], iColumn, sAlign='Center' )
         Label    ( iAttr[6], iColumn, sAlign='Center' )
         Label    ( iAttr[7], iColumn, sAlign='Center' )
         RowClose ()

      SectionClose()

   # --------------------------------------------------------------------------------
   if sDiskHistory :
      # -----------------------------------------------------------------------------
      iAccCnt += 1
      SectionOpen( 'History', iIndex=iAccCnt )
      for sTime in sorted( sDiskHistory ) :
         RowOpen  ( sClass='SmartRow' )
         Label    ( Colorize( sTime + ' :', 'Black', True ),  200 )     # TimeStamp
         RowClose ()

         sDenote = [ str( x ) for x in sorted( [ int( x ) for x in sDiskHistory[ sTime ] ] ) ]
         for sID in sDenote :
            iItem = sDiskHistory[ sTime ][ sID ]

            RowOpen  ( sClass='SmartRow' )
            Label    ( sID, 25, sAlign='Right' )          # ID
            Label    ( ':',  5,   10 )
            Label    ( iItem[0], 300 )                   # Attribut

            Label    ( Colorize( iItem[1], 'Black', True), 100, sAlign='Right'  )   # Previous RAW-Value
            Label    ( 'to', 25, sAlign='Center' )
            Label    ( Colorize( iItem[2], 'Red',   True), 100 )                   # Current RAW-Value
            RowClose ()

      # -----------------------------------------------------------------------------
      SectionClose()

   # --------------------------------------------------------------------------------
   if sAlertDev :
      Section ( 'modHddAlertSmart' )

      RowOpen  ()
      Label    ( 'SmartAlertReset',   Column_1 )
      Button   ( 'ButtonAlertReset', '- Reset -', f'{asset.PageName}-{FuncName}+reset#{sMore}', iSize=80 )
      RowClose ()

   # --------------------------------------------------------------------------------
   if not sMore.startswith( 'nvme' ) :
      RowOpen  ( sClass='SmartRow' )
      Label    ( '&nbsp;', 10 )
      RowClose ()

      Section( 'modHddEscHead' )
      RowOpen  ( sClass='SmartRow' )
      Icon     ( sIcon[ 'Higher' ] )
      Label    ( ':', 5, 10 )
      Label    ( s['modHddEscHigh'], 325 )
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Icon     ( sIcon[ 'Lower' ] )
      Label    ( ':', 5, 10 )
      Label    ( s['modHddEscLow'], 325 )
      RowClose ()

      RowOpen  ( sClass='SmartRow' )
      Icon     ( sIcon[ 'Denote' ] )
      Label    ( ':', 5, 10 )
      Label    ( s['modHddEscCritical'], 325 )
      RowClose ()

      if sAlertDev :
         RowOpen  ( sClass='SmartRow' )
         Icon     ( 'RedSquare.png' )
         Label    ( ':', 5, 10 )
         Label    ( s['modHddAlertSmart'], 325 )
         RowClose ()

      if sAttrHistory :
         RowOpen  ( sClass='SmartRow' )
         Icon     ( 'BlueHint.png' )
         Label    ( ':', 5, 10 )
         Label    ( s['modHddAlertSmartHistory'], 325 )
         RowClose ()

   # --------------------------------------------------------------------------------
   print ( '               </div> <!-- End DivScroll -->' )
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
