# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

import basics as io
from   lib    import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName = 'log'

FuncDesc = { 'IconName'     : 'Log_File.png',
             'SubName'      : asset.msg['modInfoLogName'],
             'SubText'      : asset.msg['modInfoLogText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'log+clear' ) :

         # --- Clear the Log-File "ERROR" ...
         io.ioRm  ( asset.ERROR )
         io.touch ( asset.ERROR )

         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "log"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   iOutWidth   = iWidth - 23
   iOutHeight  = iHeight -52

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight )
   # --------------------------------------------------------------------------------

   divOpenBlk ( iOutWidth, iOutHeight, sClass='WhiteMonoList' )
   print ( '<div id="ShareScroll" class="ScrollBar OverFlowHddList"> <!-- Start DivScroll -->' )
   # --------------------------------------------------------------------------------

   # --- Print content of File ...
   print ( io.ioRead( asset.ERROR ) )

   # --------------------------------------------------------------------------------
   print ( '</div> <!-- End DivScroll -->' )
   divCloseBlk ()

   # --------------------------------------------------------------------------------
   # --- "Clear" Button ausgeben ...
   if asset.sysCookies['SynoAdmin'] :
      Button1_l ( 'Clear', f'{asset.PageName}-{FuncName}+clear', sClass='BlueButton' )

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
