# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'usv'

FuncDesc = { 'IconName'     : 'Usv_Usb.png',
             'SubName'      : asset.msg['modUsvRawName'],
             'SubText'      : asset.msg['modUsvRawText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Function : "usv"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   iOutWidth   = iWidth - 23
   iOutHeight  = iHeight -17

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight )
   # --------------------------------------------------------------------------------

   divOpenBlk ( iOutWidth, iOutHeight )
   print ( '<div id="ShareScroll" class="ScrollBar OverFlowHddList"><!-- Start DivScroll -->' )

   import Nut
   try :
      iNut = Nut.getUsvNice()
   except ( BaseException ) :
      e = Nut.getException()
      print ( e )
      iNut = False

   if iNut :
      for sParent in sorted( iNut ) :
         print ( '# ------------------------------------------------------------------' )
         print ( '# Part : -%s-' % sParent )
         print ( '# ------------------------------------------------------------------' )
         for sKey in sorted( iNut[ sParent ] ) :
            print ( '%5s %-22.22s = %s' % ( ' ', sKey, iNut[ sParent ][ sKey ] ) )
   else :
      print ( 'No UPS-Device found.' )

   print ( '</div> <!-- End DivScroll -->' )
   divCloseBlk ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
