# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html   import *

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
PageName    = 'Chart'
FuncSubList = [ 'page', 'line', 'axis', 'legend', 'grid', 'index', ]

ModDesc     = f'{asset.cgiModulPath}/mod_{PageName}.json'

# -----------------------------------------------------------------------------------
# PlugIn Descriptor :
# -----------------------------------------------------------------------------------
def pluginDesc () :

   # --------------------------------------------------------------------------------
   rDict = { 'IconName'     : 'Chart.png',                        # Modul-Icon
             'Description'  : asset.msg['modChartTextMain'],      # Modul-Description
             'PageName'     : PageName,                           # Modul-Page Name
             'SubList'      : FuncSubList,                        # List of includet Sub-Functions
             'Subs'         : dict(),
           }

   # --------------------------------------------------------------------------------
   """
   if os.path.exists( ModDesc ) :
      with open( ModDesc, 'r', encoding='utf-8' ) as f:
         rDict = json.loads( f.read() )
   else :
      import basics as io
      from importlib import import_module as Package

      for sName in FuncSubList :
         Sub = Package( f'c{PageName}.{sName}' )
         rDict[ 'Subs' ][ sName ] = Sub.FuncDesc

      io.ioWrite( json.dumps( rDict, sort_keys=True, indent=4 ), ModDesc )
   """

   # --------------------------------------------------------------------------------
   import basics as io
   from importlib import import_module as Package

   for sName in FuncSubList :
      Sub = Package( f'c{PageName}.{sName}' )
      rDict[ 'Subs' ][ sName ] = Sub.FuncDesc

   io.ioWrite( json.dumps( rDict, sort_keys=True, indent=4 ), ModDesc )

   # --------------------------------------------------------------------------------
   return rDict

# -----------------------------------------------------------------------------------
# --- Display the "SUB"-Menue
# -----------------------------------------------------------------------------------
def sub( sSite, sMore ) :

   for sSub in asset.desModule[ PageName ]['SubList'] :
      if sSub == sSite : opt = True
      else             : opt = False
      menuBtn  (  asset.desModule[ PageName ]['Subs'][ sSub ]['SubName' ],
                  asset.desModule[ PageName ]['Subs'][ sSub ]['SubText' ],
                  asset.desModule[ PageName ]['Subs'][ sSub ]['iWidth'  ],
                  asset.desModule[ PageName ]['Subs'][ sSub ]['IconName'],
                  '%s-%s' % ( PageName, sSub ), opt=opt )

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
